Unit EC02C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, FTFTC_p;

procedure EC02C(var AR :Array of Real; var AI :Array of Real;
                var GR :Array of Real; var GI :Array of Real;
                N1 :Integer; N2 :Integer; D1 :Real; D2 :Real;
                ALP :Real; P :Real; L :Integer; var H :Array of Real;
                var FR :Array of Real; var FI :Array of Real);

implementation

procedure EC02C(var AR :Array of Real; var AI :Array of Real;
                var GR :Array of Real; var GI :Array of Real;
                N1 :Integer; N2 :Integer; D1 :Real; D2 :Real;
                ALP :Real; P :Real; L :Integer; var H :Array of Real;
                var FR :Array of Real; var FI :Array of Real);
var
I,J,N3,N4,N5,N6 :Integer;
B,C,C1,DW1,DW2,Q,R,R1,R2,R3,R4,R5,R6,R7,R8,S1,S2,S3,W1,W2 :Real;
const
SYS003 :Real = 6.2831853071795864769252867665590;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120;
begin
case L of
 1: goto _10;
 2: goto _30;
 3: goto _30;
 4: goto _20;
end;
_10:
Q  := 1.0;
FTFTC(AR,AI,N1,N2,Q);
_20:
Q  := 1.0;
FTFTC(GR,GI,N1,N2,Q);
goto _120;
_30:
N3  := N1 div 2 + 1;
N4  := N2 div 2 + 1;
N5  := N1 + 1;
N6  := N2 + 1;
B  := 1.0/(N1*N2);
C1  := D1*D2;
C  := 1.0/C1;
DW1  := SYS003/(N1*D1);
DW2  := SYS003/(N2*D2);
Q  := ALP*C*C;
S1  := 0.0;
S2  := 0.0;
S3  := 0.0;
for I:=1 to N1 do
 begin
  if ( I  >  N3 ) 
   then goto _40;
  W1  := DW1*(I - 1);
  goto _50;
_40:
  W1  := DW1*(N5 - I);
_50:
  for J:=1 to N2 do
   begin
    if ( J  >  N4 ) 
     then goto _60;
    W2  := DW2*(J - 1);
    goto _70;
_60:
    W2  := DW2*(N6 - J);
_70:
    R1  := AR[(I-1)+(J-1)*N1];
    R2  := AI[(I-1)+(J-1)*N1];
    R3  := GR[(I-1)+(J-1)*N1];
    R4  := GI[(I-1)+(J-1)*N1];
    R5  := R1*R1 + R2*R2;
    if ( W1  =  0.0 ) and (  W2  =  0.0 ) and (  P  =  0.0 )
     then W2  := 1.0;
    R  := 1.0 + Power(W1*W1 + W2*W2,P);
    R6  := 1.0/(R5 + Q*R);
    R7  := ((R1*R3 + R2*R4)*C)*R6;
    R8  := ((R1*R4 - R2*R3)*C)*R6;
    FR[(I-1)+(J-1)*N1] := R7;
    FI[(I-1)+(J-1)*N1] := R8;
    R3  := C1*(R1*R7 - R2*R8) - R3;
    R4  := C1*(R1*R8 + R2*R7) - R4;
    S1  := S1 + R3*R3 + R4*R4;
    R3  := (R*B)*(R7*R7 + R8*R8);
    S2  := S2 + R3;
    R4  := R*((ALP*R6)*R)*(ALP*R6)*R3;
    S3  := S3 + R4;
_80:
   end;
_90:
 end;
H[0] := Sqrt(S1*C1*B);
H[1] := Sqrt(S2*C1);
H[2] := Sqrt(H[0]*H[0] + ALP*H[1]*H[1]);
H[3] := Sqrt(S3*C)*C;
if ( L  =  3 ) 
 then goto _120;
S1  := 1.0;
for I:=1 to N1 do
 begin
  S1  := -S1;
  for J:=1 to N2 do
   begin
    S1  := -S1;
    FR[(I-1)+(J-1)*N1] := FR[(I-1)+(J-1)*N1]*S1*B;
    FI[(I-1)+(J-1)*N1] := FI[(I-1)+(J-1)*N1]*S1*B;
_100:
   end;
_110:
 end;
Q  := -1.0;
FTFTC(FR,FI,N1,N2,Q);
_120:
end;

end.
